#by 6jun15 good average speedometer
# {t}oggle (s)switch [c]ycler
#6dec13 add graffiti
#5dec13 GF graft the display list function into this
#had to refactor calc and draw routines from the wrong places
#cubeblue2.py
#Fractal interpretation by Yuliya Semibratova 29nov13
#based on lorenz.py by Stan Blank 22mar05
#OpenGL by Alex Bourd and Matthew Stiak 9oct96
#IrisGL by G Francis 9apr89, last revision 9sep96
#Correction of 1988 SGI GUIDE p2-21

#replaces include <GL/glut.h>
from OpenGL.GL import *
from OpenGL.GLUT import *
from OpenGL.GLU import *
from math import*
import sys
import time #for the speedometer

#allocate some globals
global aff
global vv
global ww
global wd
global ht
global A
global B
global MouseX
global MouseY
global bases
global tops
global aff     #current affine matrix
global flymode  #current rotating point
global fore     #(f)key is down 
global aft      #(a)key is down
global inclevel 
global decdeep 
global uselist  
global binoc
global nose
global msg


#Cross product
def cross(u,v):
  w=[u[1]*v[2]-u[2]*v[1],u[2]*v[0]-u[0]*v[2],u[0]*v[1]-u[1]*v[0]]
  return w

#Makes the magnitude one, s.t. the vector is simple to scale
def normalize(a):
  magnitude=sqrt(pow(a[0],2)+pow(a[1],2)+pow(a[2],2))
  e=[a[0]/magnitude,a[1]/magnitude,a[2]/magnitude]
  return e



#for mouse motion
aff = [[1.0, 0.0, 0.0, 0.0],
       [0.0, 1.0, 0.0, 0.0],
       [0.0, 0.0, 1.0, 0.0],
       [0.0, 0.0, -4.2, 1.0]]



#More advanced version of the midpt function. Scale can be 1.0/3.0, for example
def makePoint(u,v, scale):
  vector2=[u[0]+scale*(v[0]-u[0]),u[1]+scale*(v[1]-u[1]),u[2]+scale*(v[2]-u[2])]
  return vector2

#the most basic midpoint function
def midpt(u,v):
    w=[]
    for n in range(3):
       w.append(0.5*(u[n]+v[n]))
    return w



		
#Window size
wd = 500
ht = 500

#Mouse/ flight parameters
MouseX = wd/2
MouseY = ht/2
flymode = 0
fore = 0       #initial values
aft = 0
focal = 2      #frustum paramater
far = 13       #frustum paramater
mysiz = .01    #frustum parameter
speed = 0.03  #of fore/aft camera propagation
incdeep = 0  #provisional change recursion depth 
decdeep = 0  
uselist = 1  #toggle between naive and display lists
binoc = 0    #toggle between binoc and monoc
nose  = .06
msg = 1 

#Scale the original cube. Size= 1 makes the side length 1.
size=.25

#Amount of recursions. 0 is the original cube
recAmount=2  # I was unable to do 4 levels on my macbook safely
             # 2 runs at 400fps 3 runs at 140 fps

#declare the original cube
cube1=[[.5,-.5,.5], [.5,.5,.5], [.5,.5,-.5],[.5,-.5,-.5],[-.5,-.5,.5], [-.5,.5,.5], [-.5,.5,-.5],[-.5,-.5,-.5]]
#cube2 is not used
cube2=[[0,0,0], [size,0,0], [size,size,0],[0.0,size,0],[0,0,size], [size,0,size], [size,size,size],[0.0,size,size]]

#distance formula
def dist(u,v):
    d=(sqrt(pow(u[0]-v[0],2)+pow(u[1]-v[1],2)+pow(u[2]-v[2],2)))
    return d


#u is the point that the peak will appear above
#v, w are nearest neighbor corners
def extrudeCross(u,v,w):
    peak=[]
    line1=[u[0]-v[0],u[1]-v[1],u[2]-v[2]]
    line2=[u[0]-w[0],u[1]-w[1],u[2]-w[2]]
    n=normalize(cross(line1,line2))
    realHeight=dist(u,v)
    peak=[u[0]+realHeight*n[0],u[1]+realHeight*n[1],u[2]+realHeight*n[2]]

    return peak


#This is the array into which the points are loaded
squares=[]


#This method calculates points
def calcCubes(v1,v2,v3,v4, recDepth=0):
	#Middle of the square; used to find the center square	
	middle=midpt(v1,v3)

	#Center square
	inner1=makePoint(v1, middle,2.0/3.0)
	inner2=makePoint(v2, middle,2.0/3.0)
	inner3=makePoint(v3, middle,2.0/3.0)
	inner4=makePoint(v4, middle,2.0/3.0)

	#call A the side between v1 and v2
	a1=makePoint(v1, v2,1.0/3.0)
	a2=makePoint(v1, v2,2.0/3.0)

	#B is between v2 and v3
	b1=makePoint(v2, v3,1.0/3.0)
	b2=makePoint(v2, v3,2.0/3.0)


	#call C the side between v3 and v4
	c1=makePoint(v3, v4,1.0/3.0)
	c2=makePoint(v3, v4,2.0/3.0)


	
	#D is between v4 and v1
	d1=makePoint(v4, v1,1.0/3.0)
	d2=makePoint(v4, v1,2.0/3.0)

	#above inner1-4 (positives)
	upper1=extrudeCross(inner1, inner2, inner4)
	upper2=extrudeCross(inner2, inner3, inner1)
	upper3=extrudeCross(inner3, inner4, inner2)
	upper4=extrudeCross(inner4, inner1, inner3)


	#above inner1-4 (negatives. The same, but the parameters are in the opposite order)
	upper5=extrudeCross(inner1, inner4, inner2)
	upper6=extrudeCross(inner2, inner1, inner3)
	upper7=extrudeCross(inner3, inner2, inner4)
	upper8=extrudeCross(inner4, inner3, inner1)



		
	#prevents infinite recursion
	recDepth+=1

	
	if recDepth <=recAmount:
		#the five faces (sixth is on the previous cube) of the extrusion
		#case 1
		calcCubes(inner1,upper1,upper2,inner2, recDepth)
		squares.append(inner1)
		squares.append(upper1)
		squares.append(upper2)
		squares.append(inner2)

		calcCubes(inner2,upper2,upper3,inner3, recDepth)	
		squares.append(inner2)
		squares.append(upper2)
		squares.append(upper3)
		squares.append(inner3)		

		calcCubes(inner3,upper3,upper4,inner4, recDepth)	
		squares.append(inner3)
		squares.append(upper3)
		squares.append(upper4)
		squares.append(inner4)			


		calcCubes(inner4,upper4,upper1,inner1, recDepth)	
		squares.append(inner4)
		squares.append(upper4)
		squares.append(upper1)
		squares.append(inner1)			


		calcCubes(upper1,upper2,upper3,upper4, recDepth)	
		squares.append(upper1)
		squares.append(upper2)
		squares.append(upper3)
		squares.append(upper4)

		#case 2
		calcCubes(inner1,upper5,upper6,inner2, recDepth)
		squares.append(inner1)
		squares.append(upper5)
		squares.append(upper6)
		squares.append(inner2)

		calcCubes(inner2,upper6,upper7,inner3, recDepth)
		squares.append(inner2)
		squares.append(upper6)
		squares.append(upper7)
		squares.append(inner3)

		calcCubes(inner3,upper7,upper8,inner4, recDepth)
		squares.append(inner3)
		squares.append(upper7)
		squares.append(upper8)
		squares.append(inner4)

		calcCubes(inner4,upper8,upper5,inner1, recDepth)
		squares.append(inner4)
		squares.append(upper8)
		squares.append(upper5)
		squares.append(inner1)

		calcCubes(upper5,upper6,upper7,upper8, recDepth)
		squares.append(upper5)
		squares.append(upper6)
		squares.append(upper7)
		squares.append(upper8)

		#these are the eight other squares
		calcCubes(v1,a1,inner1,d2, recDepth)
		calcCubes(a1,a2,inner2,inner1, recDepth)
		calcCubes(a2,v2,b1,inner2, recDepth)
		calcCubes(d2,inner1,inner4,d1, recDepth)	
		calcCubes(inner2,b1,b2,inner3, recDepth)
		calcCubes(d1,inner4,c2,v4, recDepth)
		calcCubes(inner4,inner3,c1,c2, recDepth)
		calcCubes(inner3,b2,v3,c1, recDepth)



#These can be made into whatever necessary. Exist to create shading easily
colors=((1,1,0), (1,0,.5), (0.5,0,.5))

#Mousemotion parameter
brake = 1028. 

####################  list magic
## if we change level, then the list has to be remade

cubeList = None   ### not same as cubeList =[] ?

def makeList():
    global cubeList
    cubeList = glGenLists(1)
    print cubeList 
    glNewList(cubeList, GL_COMPILE)
#HERE we need to draw the entire scene once
    drawfractal()
    glEndList()

def drawfractal():
   #Draws the squares calculated in calcCubes and colors them
   glBegin(GL_QUADS)
   for i in range(len(squares)):
	   colorIndex=i%3
	   color=colors[colorIndex]
	   glColor3f(color[0],color[1],color[2])  
	   glVertex3fv(squares[i])
   glEnd()
#################end of lists
#################begin speedometer
# this is lame ... probably needs another class like clocker()
then =0 #static remember it
ii   =0  #static int count
many =42  #skips to tame on lilmac 
rate = 1
def speedometer():
   global then
   global ii
   global rate
   ii += 1 #NB ++ii doesn't work in Python
   if(ii % many  == 0):
     now=time.clock()
     lapse= now - then
     then = now
     rate=many/lapse
   return int(rate)
########## end speedometer
#################begin graffiti
def  char2wall(x,y, buf):
     glRasterPos3f(x,y,0)
     for char in buf:
        glutBitmapCharacter(GLUT_BITMAP_9_BY_15, ord(char))

def graffiti():
    glViewport(0,0,wd,ht)
    glColor3f(1,1, 1)
    #careful to do this after scene is drawn and just before swapbuffers
    glMatrixMode(GL_PROJECTION)
    glLoadIdentity()
    gluOrtho2D(0,3000,0,3000) #it's easier to place graffiti in these coords
    glMatrixMode(GL_MODELVIEW)
    glLoadIdentity()
    char2wall(80,2840,  "(ESC) fl{y} (f)ore (a)ft {u}list, {b}inoc {m}essages")
    char2wall(80,80, "Frames/sec:"+str(speedometer())) 
    char2wall(80,10, "Cubic Koch by Yuliya B., Math198, 2013 ") 
#end graffiti()

#################end graffiti

# typical display callback ... aka drawall
def display():
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
   if(binoc):
      glViewport(0,ht/4,wd/2,ht/2) 
   glMatrixMode(GL_PROJECTION)
   glLoadIdentity()
   glFrustum(-mysiz*wd/ht, mysiz*wd/ht, -mysiz, mysiz, mysiz*focal, far)
   glMatrixMode(GL_MODELVIEW)
   glLoadIdentity()
   #drawstars
   glTranslatef(-binoc*nose,0,0)
   glMultMatrixf(aff)
   if uselist==1: 
       glCallList(cubeList) #use this for displaylists
   else: drawfractal()
   if(binoc):
      glViewport(wd/2,ht/4,wd/2,ht/2) 
      glMatrixMode(GL_MODELVIEW)
      glLoadIdentity()
      glTranslatef(binoc*nose,0,0)
      glMultMatrixf(aff)
      if uselist == 1: 
         glCallList(cubeList)
      else: drawfractal()   
   glViewport(0,0,wd,ht)  
   if(msg): graffiti()
   glutSwapBuffers()
#end display()

#################### display list magic

#typical  callback 
def keyboard(key, x, y):
   global flymode  #because these globals are changed here
   global fore
   global aft 
   global recAmount
   global incdeep
   global decdeep
   global uselist
   global binoc
   global msg
   if key == chr(27) or key == 'q':
     sys.exit(0)
   if key == 'y': flymode = 1-flymode
   if key == 'f': fore = 1
   if key == 'a': aft = 1
   if key == 'l': incdeep = 1 
   if key == 'L': decdeep = 1 
   if key == 'u': uselist = 1-uselist 
   if key == 'b': binoc = 1 - binoc
   if key == 'm': msg = 1 - msg
   glutPostRedisplay()
#end keyboard()

#the callback only fetches the dimensions
def reshape(width, height):
   global wd
   global ht
   wd = width
   ht = height
#end reshape()

#Note that we must declare the globals again
def chaptrack():
   global aff
   global fore
   global aft

   dx = (MouseX-wd/2)/brake  
   dy = (MouseY-ht/2)/brake
   glMatrixMode(GL_TEXTURE)
#  glMatrixMode(GL_MODELVIEW)     #if this stack then push/pop
#   glPushMatrix()
   glLoadIdentity()
   if flymode==0:   #in turnmode, conjugate rotation
      glTranslatef(aff[3][0],aff[3][1],aff[3][2]) 
   glRotatef(dx,0,1.0,0.0)
   glRotatef(dy,1.0,0.0,0.0)
   if fore == 1 and aft == 0: glTranslatef(0.,0.,speed)
   if aft  == 1 and fore == 0: glTranslatef(0.,0.,-speed)
   if flymode==0:
      glTranslatef(-aff[3][0],-aff[3][1],-aff[3][2]) 
   glMultMatrixf(aff)
   aff = glGetFloatv(GL_TEXTURE_MATRIX)
#  aff = glGetFloatv(GL_MODELVIEW_MATRIX)
#  glPopMatrix()
   fore=0 #message to move fore/aft done 
   aft =0
#end chaptrack()
#the following was factored out of idle() where it did NOT belong
def minicubes():
   global squares
   #squares=[]
   #draws the original cube
   originalCube(cube1)
   #calculate the miniature cubes on each side
   calcCubes(cube1[0], cube1[1], cube1[2], cube1[3])
   #calcCubes(cube1[4], cube1[5], cube1[6], cube1[7])
   #calcCubes(cube1[0], cube1[4], cube1[7], cube1[3])
   #calcCubes(cube1[1], cube1[5], cube1[6], cube1[2])
   #calcCubes(cube1[0], cube1[1], cube1[5], cube1[4])
   #calcCubes(cube1[2], cube1[6], cube1[7], cube1[3])

#traditional idle
def idle():
   #minicubes()  #this showed that the factoring was successful
   chaptrack()
   glutPostRedisplay()
#end idle()

#ditto traditional mousemotion
#Note globals
def mousemotion(x,y):
   global MouseX
   global MouseY
   MouseX = x
   MouseY = y
#end mousemotion()

#Given points, make the original cube. It has six sides, so does not fit the calcCubes parameter.
def originalCube(vv):
	squares.append(vv[0])
	squares.append(vv[1])
	squares.append(vv[2])
	squares.append(vv[3])

	#squares.append(vv[4])
	#squares.append(vv[5])
	#squares.append(vv[6])
	#squares.append(vv[7])

	#squares.append(vv[0])
	#squares.append(vv[4])
	#squares.append(vv[7])
	#squares.append(vv[3])

	#squares.append(vv[1])
	#squares.append(vv[5])
	#squares.append(vv[6])
	#squares.append(vv[2])

	#squares.append(vv[0])
	#squares.append(vv[1])
	#squares.append(vv[5])
	#squares.append(vv[4])

	#squares.append(vv[2])
	#squares.append(vv[6])
	#squares.append(vv[7])
	#squares.append(vv[3])

#Traditional main subroutine
def main(argv) :
   glutInitDisplayMode(GLUT_RGB | GLUT_DEPTH | GLUT_DOUBLE)
   glutInitWindowPosition(50, 50)
   glutInitWindowSize(wd, ht)
   glutInit(argv)
   glutCreateWindow("Cubic Koch Surface")
   glutKeyboardFunc(keyboard)
   glutDisplayFunc(display)
   glutIdleFunc(idle)
   glutReshapeFunc(reshape)
   glutPassiveMotionFunc(mousemotion)
   glEnable(GL_DEPTH_TEST)
   glShadeModel(GL_SMOOTH)
#  this is the wrong place for these two functions 
   minicubes()
   makeList()  
#  but they do work here.
#  then comes the display() of either drawfractal or drawlist
   glutMainLoop()

#Necessary if we want to this program to run
main(sys.argv)
